function[opt_cond]=iter_condition(err,eps,ranks,modes);
% Internal function used by n_mode_svd_reduce.m
% Fuction checks if the mode matrices have the desired accuracy.
% Returns a boolean for the while loop.
%
% Please report bugs/fixes to maov@mrl.nyu.edu
% Copyright 2005-2025 M.A.O.Vasilescu
% Please do NOT redistribute without permission; direct requests to maov@mrl.nyu.edu

% Paper ECCV'02, vol.2350, pg.447-460./Paper ICPR'02, vol.3 pg.456-460.
% Paper CVPR'03, vol.2, pg.93-99.
% Created 2001 and Revised Feb 28, 2005 by M.A.O.Vasilescu


opt_cond=err(modes(1))<(1-eps)*ranks(1)
for i=modes(2:length(modes))
  opt_cond=opt_cond | err(modes(i))<(1-eps)*ranks(i)
end




