function [tensor] = matricize(tensor,n) 
% Matricizing flattens the tensor exposing the N-th mode in the rows
% and stacking up everything in the columns. The data is stacked up in
% the cols according to the Kiers flattening.
%
% Please report bugs/fixes to maov@mrl.nyu.edu
% Copyright 2005-2025 M.A.O.Vasilescu
% Please do NOT redistribute without permission; direct requests to maov@mrl.nyu.edu

% Paper ECCV'02, vol.2350, pg.447-460./Paper ICPR'02, vol.3 pg.456-460.
% Paper CVPR'03, vol.2, pg.93-99.
% Created 2001 and Revised Feb 28, 2005 by M.A.O.Vasilescu

s=size(tensor);
ss=size(tensor,n);
dim=prod(s); %dimention of the Eucledian space
tensor=shiftdim(tensor,n-1);
tensor=reshape(tensor,ss,dim/ss);
