function [pt]= mode_m_prod(t,m,n,big_flag);
% Multiply tensor t with matrix m along dimension/mode n
% big_flag is defaulted to 0. Set big_flag to 1 if running out of memory
% Example:
%	 randn('state',0)
%	 t=randn(3,4,5)
%	 m=randn(2,4);
%	 pt=mode_m_prod(t,m,2);
%	 size(pt)
%
% Please report bugs/fixes to maov@mrl.nyu.edu
% Copyright 2005-2025 M.A.O.Vasilescu
% Please do NOT redistribute without permission; direct requests to maov@mrl.nyu.edu

% Paper ECCV'02, vol.2350, pg.447-460./Paper ICPR'02, vol.3 pg.456-460.
% Paper CVPR'03, vol.2, pg.93-99.
% Created 2001 and Revised Feb 28, 2005 by M.A.O.Vasilescu

if nargin==3
  big_flag=0;
end;

[dims]=size(t);
maxn=length(dims);

[r c]=size(m);


%if (dims(n)~=c)
%  dims,[r c]
%  error('Size of the n-mode tensor is different than column size of the matrix');end

t=matricize(t,n);
%['Dimensions of Matricized Tensor'], size(t)

%clear V 
 if big_flag
   'big_flag'
   for i=1:size(m,1)
     v(i,:)=m(i,:)*t;
   end
    t=v;
    clear v
 else
  t=m*t;
end

clear c i

%['Dimensions of Matricized Product'], size(t)

pack
pt=tensorize(t,n,[dims(1:n-1) r dims(n+1:maxn)]);

['Dimensions of Result']
size(pt)