function[U,old_U,err]=optimize_mode(tensor,U,smode,rmodes,sR,ranks);
% Internal function used by m_mode_svd_reduce.m
% Solves for the optimal U_smodes while holding the mode matrices 
% associated with rmodes fixed.
%
% Please report bugs/fixes to maov@mrl.nyu.edu
% Copyright 2005-2025 M.A.O.Vasilescu
% Please do NOT redistribute without permission; direct requests to maov@mrl.nyu.edu

% Paper ECCV'02, vol.2350, pg.447-460./Paper ICPR'02, vol.3 pg.456-460.
% Paper CVPR'03, vol.2, pg.93-99.
% Created 2001 and Revised Feb 28, 2005 by M.A.O.Vasilescu


for i=rmodes
  tensor=mode_m_prod(tensor,U{i}(:,1:ranks(i))',i);
end
coretensor=tensor;

fcore=matricize(coretensor,smode);
[r c]=size(fcore);
%fcore=fcore-repmat(mean(fcore,2),1,c);
clear coretensor

if r<(c/2)
  covn=fcore*fcore';
  [u s v]=svds(covn,sR);
else
  [u s v]=svds(fcore,sR);
end

old_U{smode}=U{smode};
U{smode}=u(:,1:sR);
err=frobenius_norm(old_U{smode}'*U{smode})^2;


clear u s v coretensor fcore smode modes sR
