function[u]=tfastsvd(M,big_flag);
% Function used internally by m_mode_svd function
% Computes mode matrix using a fast svd /memmory efficient svd
%
% Please report bugs to maov@mrl.nyu.edu
% Copyright 2005-2025 M.A.O.Vasilescu
% Please do NOT redistribute without permission; direct requests to maov@mrl.nyu.edu

% Paper ECCV'02, vol.2350, pg.447-460./Paper ICPR'02, vol.3 pg.456-460.
% Paper CVPR'03, vol.2, pg.93-99.
% Created 2001 and Revised Feb 28, 2005 by M.A.O.Vasilescu


if nargin==1
  big_flag=0;
end

[r,c]=size(M);
if r==1
% 'r==1'
  u=1;
  [u,s,v]=svd(M,0);
elseif r<c
  %'r<c'
  M2=zeros(r,r);
  if big_flag==0 
   M2=M*M';
  else
   for i=1:r;
     for j=1:r
       [j i];
       M2(j,i)=M(j,:)*M(i,:)';
     end
   end
  end
  clear M
  [u,s2,u]=svd(M2);
  clear s2
elseif c==1
  %'c==1'
  v=1;
  s=abs(sqrt(dot(M,M)));
  u=M*v*inv(s);
  [u,s,v]=svd(M,0);
elseif c<r
  %'c<r'
  if big_flag==0
   M2t=M'*M;
  else
   M2t=zeros(c,c);
   for i=1:c;
    M2t(i,:)=M(:,i)'*M;
   end
  end
  [v,s2,v]=svd(M2t);
  %zeros(r,c);
  s=abs(sqrt(s2));
  clear M2t s2
  pack
  u=M*v*inv(s);
else
  [u,s,v]=svd(M,0);
end
